{*******************************************************
********************************************************
********************************************************
* Bits  Delphi implementation *
* written by Ekrem KOAK ( ekremkocak@hotmail.com )    *
********************************************************
********************************************************
*******************************************************}

unit UnitBits;

interface

uses
  Windows, SysUtils, Classes;

const
STREAMRATE = 2401587;
//DEMUX = STREAMRATE*8 div 50;
DEMUX = 25200;


 var
  bitpos: integer = 0;
  bitval: UINT = 0;
  bitbuf: PByteArray = nil;
  bitmask: array [0..33-1] of UINT = ($0,$1,$3,$7,$f,$1f,$3f,$7f,$ff,$1ff,$3ff,$7ff,$fff,$1fff,$3fff,$7fff,$ffff,$1ffff,$3ffff,$7ffff,$fffff,$1fffff,$3fffff,$7fffff,$ffffff,$1ffffff,$3ffffff,$7ffffff,$fffffff,$1fffffff,$3fffffff,$7fffffff,$ffffffff);

   procedure set_buf(buf: pchar;  bufsize: integer;clear: bool = true);
   function get_bits(bits: integer): integer;
   procedure set_bits(val:UINT;  bits: integer);
   function  buf_size(): integer;
   procedure set_bit_pos(newpos: UINT);

   
implementation

 uses Unit1;

procedure set_buf( buf: pchar;  bufsize: integer;  clear: bool = true);
begin


  bitpos:= 0;
  bitbuf:= pointer(buf);
  bitval:= (bitbuf[0] shl 24) or (bitbuf[1] shl 16) or (bitbuf[2] shl 8) or bitbuf[3];
  if clear then
// ZeroMemory(bitbuf,bufsize);
   FillChar(bitbuf[0], bufsize, 0);
end;


function get_bits(bits: integer): integer;
var
val: DWORD;
left: integer;
pos: integer;
begin
  
  left:=32-(bitpos and 31); 
  if bits<left
  then
  begin 
    val:= (bitval shr (left-bits)) and bitmask[bits]; 
    bitpos:= bitpos + (bits); 
  end
  else
  begin 
    val:= (bitval and bitmask[left]) shl (bits-left); 
    bitpos:= bitpos + (left); 
    bits:= bits - (left); 
    pos:=bitpos shr 3;
    bitval:= (bitbuf[pos] shl 24) or (bitbuf[pos+1] shl 16) or (bitbuf[pos+2] shl 8) or bitbuf[pos+3];
    if bits>0
    then
    begin
      val:= val or ((bitval shr (32-bits)) and bitmask[bits]);
      bitpos:= bitpos + (bits); 
    end;
  end;
  
  begin
    result:= val; 
    exit;
  end;
end;


procedure set_bits(val:UINT;  bits: integer);
var
bitsleft: integer;
begin
  val:= val and (bitmask[bits]);

  while bits>0 do
  begin
   bitsleft:=(8-( bitpos and 7));
    if bits>=bitsleft
    then
    begin
      bitbuf[ bitpos shr 3]:= bitbuf[ bitpos shr 3] or (val shr (bits-bitsleft));
      bitpos:=  bitpos + (bitsleft);
      bits:= bits - (bitsleft);
      val:= val and (bitmask[bits]);
    end
    else
    begin
       bitbuf[ bitpos shr 3]:= bitbuf[ bitpos shr 3] or (val shl (bitsleft-bits));
       bitpos:=  bitpos + (bits);
       bits:= 0;
    end;
  end;
end;

function  buf_size(): integer;
begin
  begin
    result:=  bitpos shr 3;
    exit;
  end;
end;

function get_bit_pos(): integer;
begin
  begin
    result:= bitpos ; 
    exit;
  end;
end;

function get_byte_pos(): integer;
begin
  begin
    result:= bitpos shr 3; 
    exit;
  end;
end;

procedure set_bit_pos(newpos: UINT);
var
pos: UINT;
begin
  bitpos:= newpos; 
  pos:=bitpos shr 5;
  bitval:= (bitbuf[pos] shl 24) or (bitbuf[pos+1] shl 16) or (bitbuf[pos+2] shl 8) or bitbuf[pos+3];
end;
 
procedure set_byte_pos(newpos: UINT);
begin
  set_bit_pos(newpos shl 3);
end;






end.
